ObjectInputStream

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.io
Class ObjectInputStream

    java.lang.Object
      java.io.InputStream
          java.io.ObjectInputStream

All Implemented Interfaces:
  DataInput, ObjectInput, ObjectStreamConstants

    public class ObjectInputStream

extends InputStream
implements ObjectInput, ObjectStreamConstants

An ObjectInputStream deserializes primitive data and objects previously written using an ObjectOutputStream.

ObjectOutputStream and ObjectInputStream can provide an application with persistent storage for graphs of objects when used with a FileOutputStream and FileInputStream respectively. ObjectInputStream is used to recover those objects previously serialized. Other uses include passing objects between hosts using a socket stream or for marshaling and unmarshaling arguments and parameters in a remote communication system.

ObjectInputStream ensures that the types of all objects in the graph created from the stream match the classes present in the Java Virtual Machine. Classes are loaded as required using the standard mechanisms.

Only objects that support the java.io.Serializable or java.io.Externalizable interface can be read from streams.

The method readObject is used to read an object from the stream. Java's safe casting should be used to get the desired type. In Java, strings and arrays are objects and are treated as objects during serialization. When read they need to be cast to the expected type.

Primitive data types can be read from the stream using the appropriate method on DataInput.

The default deserialization mechanism for objects restores the contents of each field to the value and type it had when it was written. Fields declared as transient or static are ignored by the deserialization process. References to other objects cause those objects to be read from the stream as necessary. Graphs of objects are restored correctly using a reference sharing mechanism. New objects are always allocated when deserializing, which prevents existing objects from being overwritten.

Reading an object is analogous to running the constructors of a new object. Memory is allocated for the object and initialized to zero (NULL). No-arg constructors are invoked for the non-serializable classes and then the fields of the serializable classes are restored from the stream starting with the serializable class closest to java.lang.object and finishing with the object's most specific class.

For example to read from a stream as written by the example in ObjectOutputStream:

            FileInputStream fis = new FileInputStream("t.tmp");
            ObjectInputStream ois = new ObjectInputStream(fis);

            int i = ois.readInt();
            String today = (String) ois.readObject();
            Date date = (Date) ois.readObject();

            ois.close();

Classes control how they are serialized by implementing either the java.io.Serializable or java.io.Externalizable interfaces.

Implementing the Serializable interface allows object serialization to save and restore the entire state of the object and it allows classes to evolve between the time the stream is written and the time it is read. It automatically traverses references between objects, saving and restoring entire graphs.

Serializable classes that require special handling during the serialization and deserialization process should implement the following methods:

     private void writeObject(java.io.ObjectOutputStream stream)
         throws IOException;
     private void readObject(java.io.ObjectInputStream stream)
         throws IOException, ClassNotFoundException;
     private void readObjectNoData()
         throws ObjectStreamException;

The readObject method is responsible for reading and restoring the state of the object for its particular class using data written to the stream by the corresponding writeObject method. The method does not need to concern itself with the state belonging to its superclasses or subclasses. State is restored by reading data from the ObjectInputStream for the individual fields and making assignments to the appropriate fields of the object. Reading primitive data types is supported by DataInput.

Any attempt to read object data which exceeds the boundaries of the custom data written by the corresponding writeObject method will cause an OptionalDataException to be thrown with an eof field value of true. Non-object reads which exceed the end of the allotted data will reflect the end of data in the same way that they would indicate the end of the stream: bytewise reads will return -1 as the byte read or number of bytes read, and primitive reads will throw EOFExceptions. If there is no corresponding writeObject method, then the end of default serialized data marks the end of the allotted data.

Primitive and object read calls issued from within a readExternal method behave in the same manner--if the stream is already positioned at the end of data written by the corresponding writeExternal method, object reads will throw OptionalDataExceptions with eof set to true, bytewise reads will return -1, and primitive reads will throw EOFExceptions. Note that this behavior does not hold for streams written with the old `ObjectStreamConstants.PROTOCOL_VERSION_1` protocol, in which the end of data written by writeExternal methods is not demarcated, and hence cannot be detected.

The readObjectNoData method is responsible for initializing the state of the object for its particular class in the event that the serialization stream does not list the given class as a superclass of the object being deserialized. This may occur in cases where the receiving party uses a different version of the deserialized instance's class than the sending party, and the receiver's version extends classes that are not extended by the sender's version. This may also occur if the serialization stream has been tampered; hence, readObjectNoData is useful for initializing deserialized objects properly despite a "hostile" or incomplete source stream.

Serialization does not read or assign values to the fields of any object that does not implement the java.io.Serializable interface. Subclasses of Objects that are not serializable can be serializable. In this case the non-serializable class must have a no-arg constructor to allow its fields to be initialized. In this case it is the responsibility of the subclass to save and restore the state of the non-serializable class. It is frequently the case that the fields of that class are accessible (public, package, or protected) or that there are get and set methods that can be used to restore the state.

Any exception that occurs while deserializing an object will be caught by the ObjectInputStream and abort the reading process.

Implementing the Externalizable interface allows the object to assume complete control over the contents and format of the object's serialized form. The methods of the Externalizable interface, writeExternal and readExternal, are called to save and restore the objects state. When implemented by a class they can write and read their own state using all of the methods of ObjectOutput and ObjectInput. It is the responsibility of the objects to handle any versioning that occurs.

Since:
  JDK1.1
Version:
  1.135, 01/09/15
Author:
  Mike Warres, Roger Riggs
See Also:
  `DataInput`, `ObjectOutputStream`, `Serializable`, Object Serialization Specification, Section 3, Object Input Classes

Nested Class Summary
`static class` | `ObjectInputStream.GetField` Provide access to the persistent fields read from the input stream.

Field Summary

Fields inherited from interface java.io.ObjectStreamConstants
`baseWireHandle, PROTOCOL_VERSION_1, PROTOCOL_VERSION_2, SC_BLOCK_DATA, SC_EXTERNALIZABLE, SC_SERIALIZABLE, SC_WRITE_METHOD, STREAM_MAGIC, STREAM_VERSION, SUBCLASS_IMPLEMENTATION_PERMISSION, SUBSTITUTION_PERMISSION, TC_ARRAY, TC_BASE, TC_BLOCKDATA, TC_BLOCKDATALONG, TC_CLASS, TC_CLASSDESC, TC_ENDBLOCKDATA, TC_EXCEPTION, TC_LONGSTRING, TC_MAX, TC_NULL, TC_OBJECT, TC_PROXYCLASSDESC, TC_REFERENCE, TC_RESET, TC_STRING`

Constructor Summary
`ObjectInputStream(InputStream in)` Creates an ObjectInputStream that reads from the specified InputStream.

Method Summary
`int` | `available()` Returns the number of bytes that can be read without blocking.
`void` | `close()` Closes the input stream.
`void` | `defaultReadObject()` Read the non-static and non-transient fields of the current class from this stream.
`int` | `read()` Reads a byte of data.
`int` | `read(byte[] buf, int off, int len)` Reads into an array of bytes.
`boolean` | `readBoolean()` Reads in a boolean.
`byte` | `readByte()` Reads an 8 bit byte.
`char` | `readChar()` Reads a 16 bit char.
`double` | `readDouble()` Reads a 64 bit double.
`ObjectInputStream.GetField` | `readFields()` Reads the persistent fields from the stream and makes them available by name.
`float` | `readFloat()` Reads a 32 bit float.
`void` | `readFully(byte[] buf)` Reads bytes, blocking until all bytes are read.
`void` | `readFully(byte[] buf, int off, int len)` Reads bytes, blocking until all bytes are read.
`int` | `readInt()` Reads a 32 bit int.
`String` | `readLine()` Deprecated. This method does not properly convert bytes to characters. see DataInputStream for the details and alternatives.
`long` | `readLong()` Reads a 64 bit long.
`Object` | `readObject()` Read an object from the ObjectInputStream.
`short` | `readShort()` Reads a 16 bit short.
`Object` | `readUnshared()` Reads an "unshared" object from the ObjectInputStream.
`int` | `readUnsignedByte()` Reads an unsigned 8 bit byte.
`int` | `readUnsignedShort()` Reads an unsigned 16 bit short.
`String` | `readUTF()` Reads a UTF format String.
`void` | `registerValidation(ObjectInputValidation obj, int prio)` Register an object to be validated before the graph is returned.
`int` | `skipBytes(int len)` Skips bytes, block until all bytes are skipped.

Methods inherited from class java.io.InputStream
`mark, markSupported, read, reset, skip`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.io.ObjectInput
`read, skip`

Constructor Detail

### ObjectInputStream

    public ObjectInputStream(InputStream in)
                      throws IOException

  Creates an ObjectInputStream that reads from the specified InputStream. A serialization stream header is read from the stream and verified. This constructor will block until the corresponding ObjectOutputStream has written and flushed the header.

  If a security manager is installed, this constructor will check for the "enableSubclassImplementation" SerializablePermission when invoked directly or indirectly by the constructor of a subclass which overrides the ObjectInputStream.readFields or ObjectInputStream.readUnshared methods.

  Parameters:
    `in` - input stream to read from
  Throws:
    `StreamCorruptedException` - if the stream header is incorrect
    `IOException` - if an I/O error occurs while reading stream header
    `SecurityException` - if untrusted subclass illegally overrides security-sensitive methods
    `NullPointerException` - if `in` is `null`
  See Also:
    `ObjectInputStream()`, `readFields()`, `ObjectOutputStream.ObjectOutputStream(OutputStream).`

Method Detail

### readObject

    public final Object readObject()
                            throws OptionalDataException,
                                   ClassNotFoundException,
                                   IOException

  Read an object from the ObjectInputStream. The class of the object, the signature of the class, and the values of the non-transient and non-static fields of the class and all of its supertypes are read. Default deserializing for a class can be overriden using the writeObject and readObject methods. Objects referenced by this object are read transitively so that a complete equivalent graph of objects is reconstructed by readObject.

  The root object is completly restored when all of its fields and the objects it references are completely restored. At this point the object validation callbacks are executed in order based on their registered priorities. The callbacks are registered by objects (in the readObject special methods) as they are individually restored. Exceptions are thrown for problems with the InputStream and for classes that should not be deserialized. All exceptions are fatal to the InputStream and leave it in an indeterminate state; it is up to the caller to ignore or recover the stream state.

  Specified by:
    `readObject` in interface `ObjectInput`
  Returns:
    the object read from the stream
  Throws:
    `ClassNotFoundException` - Class of a serialized object cannot be found.
    `InvalidClassException` - Something is wrong with a class used by serialization.
    `StreamCorruptedException` - Control information in the stream is inconsistent.
    `OptionalDataException` - Primitive data was found in the stream instead of objects.
    `IOException` - Any of the usual Input/Output related exceptions.

### readUnshared

    public Object readUnshared()
                        throws IOException,
                               ClassNotFoundException

  Reads an "unshared" object from the ObjectInputStream. This method is identical to readObject, except that it prevents subsequent calls to readObject and readUnshared from returning additional references to the deserialized instance obtained via this call. Specifically:
  - If readUnshared is called to deserialize a back-reference (the stream representation of an object which has been written previously to the stream), an ObjectStreamException will be thrown.
  - If readUnshared returns successfully, then any subsequent attempts to deserialize back-references to the stream handle deserialized by readUnshared will cause an ObjectStreamException to be thrown.
  Deserializing an object via readUnshared invalidates the stream handle associated with the returned object. Note that this in itself does not always guarantee that the reference returned by readUnshared is unique; the deserialized object may define a readResolve method which returns an object visible to other parties, or readUnshared may return a Class object obtainable elsewhere in the stream or through external means.

  However, for objects which are not instances of java.lang.Class and do not define readResolve methods, readUnshared guarantees that the returned object reference is unique and cannot be obtained a second time from the ObjectInputStream that created it, even if the underlying data stream has been manipulated. This guarantee applies only to the base-level object returned by readUnshared, and not to any transitively referenced sub-objects in the returned object graph.

  ObjectInputStream subclasses which override this method can only be constructed in security contexts possessing the "enableSubclassImplementation" SerializablePermission; any attempt to instantiate such a subclass without this permission will cause a SecurityException to be thrown.

  Returns:
    reference to deserialized object
  Throws:
    `ClassNotFoundException` - if class of an object to deserialize cannot be found
    `StreamCorruptedException` - if control information in the stream is inconsistent
    `ObjectStreamException` - if object to deserialize has already appeared in stream
    `OptionalDataException` - if primitive data is next in stream
    `IOException` - if an I/O error occurs during deserialization

### defaultReadObject

    public void defaultReadObject()
                           throws IOException,
                                  ClassNotFoundException

  Read the non-static and non-transient fields of the current class from this stream. This may only be called from the readObject method of the class being deserialized. It will throw the NotActiveException if it is called otherwise.

  Throws:
    `ClassNotFoundException` - if the class of a serialized object could not be found.
    `IOException` - if an I/O error occurs.
    `NotActiveException` - if the stream is not currently reading objects.

### readFields

    public ObjectInputStream.GetField readFields()
                                          throws IOException,
                                                 ClassNotFoundException,
                                                 NotActiveException

  Reads the persistent fields from the stream and makes them available by name.

  Returns:
    the `GetField` object representing the persistent fields of the object being deserialized
  Throws:
    `ClassNotFoundException` - if the class of a serialized object could not be found.
    `IOException` - if an I/O error occurs.
    `NotActiveException` - if the stream is not currently reading objects.
  Since:
    1.2

### registerValidation

    public void registerValidation(ObjectInputValidation obj,
                                   int prio)
                            throws NotActiveException,
                                   InvalidObjectException

  Register an object to be validated before the graph is returned. While similar to resolveObject these validations are called after the entire graph has been reconstituted. Typically, a readObject method will register the object with the stream so that when all of the objects are restored a final set of validations can be performed.

  Parameters:
    `obj` - the object to receive the validation callback.
    `prio` - controls the order of callbacks;zero is a good default. Use higher numbers to be called back earlier, lower numbers for later callbacks. Within a priority, callbacks are processed in no particular order.
  Throws:
    `NotActiveException` - The stream is not currently reading objects so it is invalid to register a callback.
    `InvalidObjectException` - The validation object is null.

### read

    public int read()
             throws IOException

  Reads a byte of data. This method will block if no input is available.

  Specified by:
    `read` in interface `ObjectInput`
  Specified by:
    `read` in class `InputStream`
  Returns:
    the byte read, or -1 if the end of the stream is reached.
  Throws:
    `IOException` - If an I/O error has occurred.

### read

    public int read(byte[] buf,
                    int off,
                    int len)
             throws IOException

  Reads into an array of bytes. This method will block until some input is available. Consider using java.io.DataInputStream.readFully to read exactly 'length' bytes.

  Specified by:
    `read` in interface `ObjectInput`
  Overrides:
    `read` in class `InputStream`
  Parameters:
    `b` - the buffer into which the data is read
    `off` - the start offset of the data
    `len` - the maximum number of bytes read
  Returns:
    the actual number of bytes read, -1 is returned when the end of the stream is reached.
  Throws:
    `IOException` - If an I/O error has occurred.
  See Also:
    `DataInputStream.readFully(byte[],int,int)`

### available

    public int available()
                  throws IOException

  Returns the number of bytes that can be read without blocking.

  Specified by:
    `available` in interface `ObjectInput`
  Overrides:
    `available` in class `InputStream`
  Returns:
    the number of available bytes.
  Throws:
    `IOException` - if there are I/O errors while reading from the underlying `InputStream`

### close

    public void close()
               throws IOException

  Closes the input stream. Must be called to release any resources associated with the stream.

  Specified by:
    `close` in interface `ObjectInput`
  Overrides:
    `close` in class `InputStream`
  Throws:
    `IOException` - If an I/O error has occurred.

### readBoolean

    public boolean readBoolean()
                        throws IOException

  Reads in a boolean.

  Specified by:
    `readBoolean` in interface `DataInput`
  Returns:
    the boolean read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readByte

    public byte readByte()
                  throws IOException

  Reads an 8 bit byte.

  Specified by:
    `readByte` in interface `DataInput`
  Returns:
    the 8 bit byte read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readUnsignedByte

    public int readUnsignedByte()
                         throws IOException

  Reads an unsigned 8 bit byte.

  Specified by:
    `readUnsignedByte` in interface `DataInput`
  Returns:
    the 8 bit byte read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readChar

    public char readChar()
                  throws IOException

  Reads a 16 bit char.

  Specified by:
    `readChar` in interface `DataInput`
  Returns:
    the 16 bit char read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readShort

    public short readShort()
                    throws IOException

  Reads a 16 bit short.

  Specified by:
    `readShort` in interface `DataInput`
  Returns:
    the 16 bit short read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readUnsignedShort

    public int readUnsignedShort()
                          throws IOException

  Reads an unsigned 16 bit short.

  Specified by:
    `readUnsignedShort` in interface `DataInput`
  Returns:
    the 16 bit short read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readInt

    public int readInt()
                throws IOException

  Reads a 32 bit int.

  Specified by:
    `readInt` in interface `DataInput`
  Returns:
    the 32 bit integer read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readLong

    public long readLong()
                  throws IOException

  Reads a 64 bit long.

  Specified by:
    `readLong` in interface `DataInput`
  Returns:
    the read 64 bit long.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readFloat

    public float readFloat()
                    throws IOException

  Reads a 32 bit float.

  Specified by:
    `readFloat` in interface `DataInput`
  Returns:
    the 32 bit float read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readDouble

    public double readDouble()
                      throws IOException

  Reads a 64 bit double.

  Specified by:
    `readDouble` in interface `DataInput`
  Returns:
    the 64 bit double read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readFully

    public void readFully(byte[] buf)
                   throws IOException

  Reads bytes, blocking until all bytes are read.

  Specified by:
    `readFully` in interface `DataInput`
  Parameters:
    `buf` - the buffer into which the data is read
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readFully

    public void readFully(byte[] buf,
                          int off,
                          int len)
                   throws IOException

  Reads bytes, blocking until all bytes are read.

  Specified by:
    `readFully` in interface `DataInput`
  Parameters:
    `buf` - the buffer into which the data is read
    `off` - the start offset of the data
    `len` - the maximum number of bytes to read
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### skipBytes

    public int skipBytes(int len)
                  throws IOException

  Skips bytes, block until all bytes are skipped.

  Specified by:
    `skipBytes` in interface `DataInput`
  Parameters:
    `len` - the number of bytes to be skipped
  Returns:
    the actual number of bytes skipped.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readLine

    public String readLine()
                    throws IOException

  Deprecated. This method does not properly convert bytes to characters. see DataInputStream for the details and alternatives.

  Reads in a line that has been terminated by a \n, \r, \r\n or EOF.

  Specified by:
    `readLine` in interface `DataInput`
  Returns:
    a String copy of the line.
  Throws:
    `IOException` - if there are I/O errors while reading from the underlying `InputStream`

### readUTF

    public String readUTF()
                   throws IOException

  Reads a UTF format String.

  Specified by:
    `readUTF` in interface `DataInput`
  Returns:
    the String.
  Throws:
    `IOException` - if there are I/O errors while reading from the underlying `InputStream`
    `UTFDataFormatException` - if read bytes do not represent a valid UTF-8 encoding of a string

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD